import CloudKernel from 'mpserverless-sdk-core';
import * as $tea from '@alicloud/tea-typescript';
export declare class SendSmsResponse extends $tea.Model {
    requestId: string;
    code: string;
    message: string;
    bizId: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class SendBatchSmsResponse extends $tea.Model {
    requestId: string;
    code: string;
    message: string;
    bizId: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class QuerySmsResponse extends $tea.Model {
    requestId: string;
    code: string;
    message: string;
    smsSendDetailDTOs: SendDetailInfo;
    totalCount: number;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class SendDetailInfo extends $tea.Model {
    smsSendDetailDTO: {
        [key: string]: any;
    }[];
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export default class Client {
    _kernel: CloudKernel;
    constructor(_kernel: CloudKernel);
    send(phoneNumbers: string, signName: string, templateCode: string, templateParam: string): Promise<SendSmsResponse>;
    batchSend(phoneNumberJson: {
        [key: string]: any;
    }, signNameJson: {
        [key: string]: any;
    }, templateCode: string, templateParamJson: string): Promise<SendBatchSmsResponse>;
    query(phoneNumber: string, sendDate: string, pageSize: number, currentPage: number): Promise<QuerySmsResponse>;
    preciseQuery(phoneNumber: string, sendDate: string, pageSize: number, currentPage: number, bizId: string): Promise<QuerySmsResponse>;
}
