"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const $tea = __importStar(require("@alicloud/tea-typescript"));
class SendSmsResponse extends $tea.Model {
    constructor(map) {
        super(map);
    }
    static names() {
        return {
            requestId: 'RequestId',
            code: 'Code',
            message: 'Message',
            bizId: 'BizId',
        };
    }
    static types() {
        return {
            requestId: 'string',
            code: 'string',
            message: 'string',
            bizId: 'string',
        };
    }
}
exports.SendSmsResponse = SendSmsResponse;
class SendBatchSmsResponse extends $tea.Model {
    constructor(map) {
        super(map);
    }
    static names() {
        return {
            requestId: 'RequestId',
            code: 'Code',
            message: 'Message',
            bizId: 'BizId',
        };
    }
    static types() {
        return {
            requestId: 'string',
            code: 'string',
            message: 'string',
            bizId: 'string',
        };
    }
}
exports.SendBatchSmsResponse = SendBatchSmsResponse;
class QuerySmsResponse extends $tea.Model {
    constructor(map) {
        super(map);
    }
    static names() {
        return {
            requestId: 'RequestId',
            code: 'Code',
            message: 'Message',
            smsSendDetailDTOs: 'SmsSendDetailDTOs',
            totalCount: 'TotalCount',
        };
    }
    static types() {
        return {
            requestId: 'string',
            code: 'string',
            message: 'string',
            smsSendDetailDTOs: SendDetailInfo,
            totalCount: 'number',
        };
    }
}
exports.QuerySmsResponse = QuerySmsResponse;
class SendDetailInfo extends $tea.Model {
    constructor(map) {
        super(map);
    }
    static names() {
        return {
            smsSendDetailDTO: 'SmsSendDetailDTO',
        };
    }
    static types() {
        return {
            smsSendDetailDTO: { 'type': 'array', 'itemType': 'object' },
        };
    }
}
exports.SendDetailInfo = SendDetailInfo;
class Client {
    constructor(_kernel) {
        this._kernel = _kernel;
    }
    async send(phoneNumbers, signName, templateCode, templateParam) {
        let params = {
            PhoneNumbers: phoneNumbers,
            SignName: signName,
            TemplateCode: templateCode,
            TemplateParam: templateParam,
        };
        return $tea.cast(await this._kernel.invokePre("alicloud-dysms", "SendSms", params), new SendSmsResponse({}));
    }
    async batchSend(phoneNumberJson, signNameJson, templateCode, templateParamJson) {
        let params = {
            PhoneNumberJson: phoneNumberJson,
            SignNameJson: signNameJson,
            TemplateCode: templateCode,
            TemplateParamJson: templateParamJson,
        };
        return $tea.cast(await this._kernel.invokePre("alicloud-dysms", "SendBatchSms", params), new SendBatchSmsResponse({}));
    }
    async query(phoneNumber, sendDate, pageSize, currentPage) {
        let params = {
            PhoneNumber: phoneNumber,
            SendDate: sendDate,
            PageSize: pageSize,
            CurrentPage: currentPage,
        };
        return $tea.cast(await this._kernel.invokePre("alicloud-dysms", "QuerySendDetails", params), new QuerySmsResponse({}));
    }
    async preciseQuery(phoneNumber, sendDate, pageSize, currentPage, bizId) {
        let params = {
            PhoneNumber: phoneNumber,
            SendDate: sendDate,
            PageSize: pageSize,
            CurrentPage: currentPage,
            BizId: bizId,
        };
        return $tea.cast(await this._kernel.invokePre("alicloud-dysms", "QuerySendDetails", params), new QuerySmsResponse({}));
    }
}
exports.default = Client;
//# sourceMappingURL=client.js.map