"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const $tea = __importStar(require("@alicloud/tea-typescript"));
class AlipaySystemOauthTokenResponse extends $tea.Model {
    constructor(map) {
        super(map);
    }
    static names() {
        return {
            code: 'code',
            msg: 'msg',
            subCode: 'subCode',
            subMsg: 'subMsg',
            userId: 'userId',
            accessToken: 'accessToken',
            expiresIn: 'expiresIn',
            refreshToken: 'refreshToken',
            reExpiresIn: 'reExpiresIn',
        };
    }
    static types() {
        return {
            code: 'string',
            msg: 'string',
            subCode: 'string',
            subMsg: 'string',
            userId: 'string',
            accessToken: 'string',
            expiresIn: 'number',
            refreshToken: 'string',
            reExpiresIn: 'number',
        };
    }
}
exports.AlipaySystemOauthTokenResponse = AlipaySystemOauthTokenResponse;
class Client {
    constructor(_kernel) {
        this._kernel = _kernel;
    }
    async getToken(code) {
        let params = {
            grant_type: "authorization_code",
            code: code,
        };
        return $tea.cast(await this._kernel.invoke("alipay.system.oauth.token", params), new AlipaySystemOauthTokenResponse({}));
    }
    async refreshToken(refreshToken) {
        let params = {
            grant_type: "refresh_token",
            refresh_token: refreshToken,
        };
        return $tea.cast(await this._kernel.invoke("alipay.system.oauth.token", params), new AlipaySystemOauthTokenResponse({}));
    }
}
exports.default = Client;
//# sourceMappingURL=client.js.map