"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const mpserverless_sdk_core_1 = __importDefault(require("mpserverless-sdk-core"));
const upper_first_1 = __importDefault(require("./utils/upper-first"));
const set_1 = __importDefault(require("./utils/set"));
const client_1 = __importDefault(require("./aliyun/shortMessage/client"));
const client_2 = __importDefault(require("./base/oauth/client"));
const client_3 = __importDefault(require("./base/qrcode/client"));
const client_4 = __importDefault(require("./marketing/templateMessage/client"));
const client_5 = __importDefault(require("./member/identification/client"));
const client_6 = __importDefault(require("./payment/common/client"));
const client_7 = __importDefault(require("./payment/faceToFace/client"));
const client_8 = __importDefault(require("./payment/huabei/client"));
const client_9 = __importDefault(require("./security/textRisk/client"));
class CloudSDK extends mpserverless_sdk_core_1.default {
    registerService(namespace, service, alias) {
        set_1.default(this, namespace, service);
        // this[namespace] = service;
        if (alias) {
            set_1.default(this, alias, service);
        }
        else {
            const ns = namespace.split('.').map(str => upper_first_1.default(str)).join('.');
            set_1.default(this, ns, service);
        }
    }
}
const cloud = new CloudSDK();
[
    ['aliyun.shortMessage', new client_1.default(cloud)],
    ['base.oauth', new client_2.default(cloud), 'Base.OAuth'],
    ['base.qrcode', new client_3.default(cloud)],
    ['marketing.templateMessage', new client_4.default(cloud)],
    ['member.identification', new client_5.default(cloud)],
    ['payment.common', new client_6.default(cloud)],
    ['payment.faceToFace', new client_7.default(cloud)],
    ['payment.huabei', new client_8.default(cloud)],
    ['security.textRisk', new client_9.default(cloud)]
].forEach(item => {
    const [key, service, alias = ''] = item;
    cloud.registerService(key, service, alias);
});
exports.default = cloud;
//# sourceMappingURL=index.js.map