"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const $tea = __importStar(require("@alicloud/tea-typescript"));
class IdentityParam extends $tea.Model {
    constructor(map) {
        super(map);
    }
    static names() {
        return {
            identityType: 'identityType',
            certType: 'certType',
            certName: 'certName',
            certNo: 'certNo',
        };
    }
    static types() {
        return {
            identityType: 'string',
            certType: 'string',
            certName: 'string',
            certNo: 'string',
        };
    }
}
exports.IdentityParam = IdentityParam;
class MerchantConfig extends $tea.Model {
    constructor(map) {
        super(map);
    }
    static names() {
        return {
            returnUrl: 'returnUrl',
        };
    }
    static types() {
        return {
            returnUrl: 'string',
        };
    }
}
exports.MerchantConfig = MerchantConfig;
class AlipayUserCertifyOpenInitializeResponse extends $tea.Model {
    constructor(map) {
        super(map);
    }
    static names() {
        return {
            code: 'code',
            msg: 'msg',
            subCode: 'subCode',
            subMsg: 'subMsg',
            certifyId: 'certifyId',
        };
    }
    static types() {
        return {
            code: 'string',
            msg: 'string',
            subCode: 'string',
            subMsg: 'string',
            certifyId: 'string',
        };
    }
}
exports.AlipayUserCertifyOpenInitializeResponse = AlipayUserCertifyOpenInitializeResponse;
class AlipayUserCertifyOpenCertifyResponse extends $tea.Model {
    constructor(map) {
        super(map);
    }
    static names() {
        return {
            body: 'body',
        };
    }
    static types() {
        return {
            body: 'string',
        };
    }
}
exports.AlipayUserCertifyOpenCertifyResponse = AlipayUserCertifyOpenCertifyResponse;
class AlipayUserCertifyOpenQueryResponse extends $tea.Model {
    constructor(map) {
        super(map);
    }
    static names() {
        return {
            code: 'code',
            msg: 'msg',
            subCode: 'subCode',
            subMsg: 'subMsg',
            passed: 'passed',
            identityInfo: 'identityInfo',
            materialInfo: 'materialInfo',
        };
    }
    static types() {
        return {
            code: 'string',
            msg: 'string',
            subCode: 'string',
            subMsg: 'string',
            passed: 'string',
            identityInfo: 'string',
            materialInfo: 'string',
        };
    }
}
exports.AlipayUserCertifyOpenQueryResponse = AlipayUserCertifyOpenQueryResponse;
class Client {
    constructor(_kernel) {
        this._kernel = _kernel;
    }
    async init(outerOrderNo, bizCode, identityParam, merchantConfig) {
        let params = {
            outer_order_no: outerOrderNo,
            biz_code: bizCode,
            identity_param: identityParam,
            merchant_config: merchantConfig,
        };
        return $tea.cast(await this._kernel.invoke("alipay.user.certify.open.initialize", params), new AlipayUserCertifyOpenInitializeResponse({}));
    }
    async certify(certifyId) {
        let params = {
            certify_id: certifyId,
            pageExec: "get",
        };
        let result = await this._kernel.invokeWithPageExe("alipay.user.certify.open.certify", params);
        let response = {
            body: result,
        };
        return $tea.cast(response, new AlipayUserCertifyOpenCertifyResponse({}));
    }
    async query(certifyId) {
        let params = {
            certify_id: certifyId,
        };
        return $tea.cast(await this._kernel.invoke("alipay.user.certify.open.query", params), new AlipayUserCertifyOpenQueryResponse({}));
    }
}
exports.default = Client;
//# sourceMappingURL=client.js.map