import CloudKernel from 'mpserverless-sdk-core';
import * as $tea from '@alicloud/tea-typescript';
export declare class TradeFundBill extends $tea.Model {
    fundChannel: string;
    bankCode: string;
    amount: string;
    realAmount: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class TradeSettleDetail extends $tea.Model {
    operationType: string;
    operationSerialNo: string;
    operationDt: string;
    transOut: string;
    transIn: string;
    amount: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class TradeSettleInfo extends $tea.Model {
    tradeSettleDetailList: TradeSettleDetail[];
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class PresetPayToolInfo extends $tea.Model {
    amount: string[];
    assertTypeCode: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class AlipayTradeCreateResponse extends $tea.Model {
    code: string;
    msg: string;
    subCode: string;
    subMsg: string;
    outTradeNo: string;
    tradeNo: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class AlipayTradeQueryResponse extends $tea.Model {
    code: string;
    msg: string;
    subCode: string;
    subMsg: string;
    tradeNo: string;
    outTradeNo: string;
    buyerLogonId: string;
    tradeStatus: string;
    totalAmount: string;
    transCurrency: string;
    settleCurrency: string;
    settleAmount: string;
    payCurrency: string;
    payAmount: string;
    settleTransRate: string;
    transPayRate: string;
    buyerPayAmount: string;
    pointAmount: string;
    invoiceAmount: string;
    sendPayDate: string;
    receiptAmount: string;
    storeId: string;
    terminalId: string;
    fundBillList: TradeFundBill[];
    storeName: string;
    buyerUserId: string;
    chargeAmount: string;
    chargeFlags: string;
    settlementId: string;
    tradeSettleInfo: TradeSettleInfo[];
    authTradePayMode: string;
    buyerUserType: string;
    mdiscountAmount: string;
    discountAmount: string;
    buyerUserName: string;
    subject: string;
    body: string;
    alipaySubMerchantId: string;
    extInfos: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class AlipayTradeRefundResponse extends $tea.Model {
    code: string;
    msg: string;
    subCode: string;
    subMsg: string;
    tradeNo: string;
    outTradeNo: string;
    buyerLogonId: string;
    fundChange: string;
    refundFee: string;
    refundCurrency: string;
    gmtRefundPay: string;
    refundDetailItemList: TradeFundBill[];
    storeName: string;
    buyerUserId: string;
    refundPresetPaytoolList: PresetPayToolInfo[];
    refundSettlementId: string;
    presentRefundBuyerAmount: string;
    presentRefundDiscountAmount: string;
    presentRefundMdiscountAmount: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class AlipayTradeCloseResponse extends $tea.Model {
    code: string;
    msg: string;
    subCode: string;
    subMsg: string;
    tradeNo: string;
    outTradeNo: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class AlipayTradeCancelResponse extends $tea.Model {
    code: string;
    msg: string;
    subCode: string;
    subMsg: string;
    tradeNo: string;
    outTradeNo: string;
    retryFlag: string;
    action: string;
    gmtRefundPay: string;
    refundSettlementId: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export default class Client {
    _kernel: CloudKernel;
    constructor(_kernel: CloudKernel);
    create(subject: string, outTradeNo: string, totalAmount: string, buyerId: string): Promise<AlipayTradeCreateResponse>;
    query(tradeNo: string): Promise<AlipayTradeQueryResponse>;
    refund(outTradeNo: string, refundAmount: string): Promise<AlipayTradeRefundResponse>;
    close(outTradeNo: string): Promise<AlipayTradeCloseResponse>;
    cancel(outTradeNo: string): Promise<AlipayTradeCancelResponse>;
}
