"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const $tea = __importStar(require("@alicloud/tea-typescript"));
class TradeFundBill extends $tea.Model {
    constructor(map) {
        super(map);
    }
    static names() {
        return {
            fundChannel: 'fundChannel',
            bankCode: 'bankCode',
            amount: 'amount',
            realAmount: 'realAmount',
        };
    }
    static types() {
        return {
            fundChannel: 'string',
            bankCode: 'string',
            amount: 'string',
            realAmount: 'string',
        };
    }
}
exports.TradeFundBill = TradeFundBill;
class TradeSettleDetail extends $tea.Model {
    constructor(map) {
        super(map);
    }
    static names() {
        return {
            operationType: 'operationType',
            operationSerialNo: 'operationSerialNo',
            operationDt: 'operationDt',
            transOut: 'transOut',
            transIn: 'transIn',
            amount: 'amount',
        };
    }
    static types() {
        return {
            operationType: 'string',
            operationSerialNo: 'string',
            operationDt: 'string',
            transOut: 'string',
            transIn: 'string',
            amount: 'string',
        };
    }
}
exports.TradeSettleDetail = TradeSettleDetail;
class TradeSettleInfo extends $tea.Model {
    constructor(map) {
        super(map);
    }
    static names() {
        return {
            tradeSettleDetailList: 'tradeSettleDetailList',
        };
    }
    static types() {
        return {
            tradeSettleDetailList: { 'type': 'array', 'itemType': TradeSettleDetail },
        };
    }
}
exports.TradeSettleInfo = TradeSettleInfo;
class PresetPayToolInfo extends $tea.Model {
    constructor(map) {
        super(map);
    }
    static names() {
        return {
            amount: 'amount',
            assertTypeCode: 'assertTypeCode',
        };
    }
    static types() {
        return {
            amount: { 'type': 'array', 'itemType': 'string' },
            assertTypeCode: 'string',
        };
    }
}
exports.PresetPayToolInfo = PresetPayToolInfo;
class AlipayTradeCreateResponse extends $tea.Model {
    constructor(map) {
        super(map);
    }
    static names() {
        return {
            code: 'code',
            msg: 'msg',
            subCode: 'subCode',
            subMsg: 'subMsg',
            outTradeNo: 'outTradeNo',
            tradeNo: 'tradeNo',
        };
    }
    static types() {
        return {
            code: 'string',
            msg: 'string',
            subCode: 'string',
            subMsg: 'string',
            outTradeNo: 'string',
            tradeNo: 'string',
        };
    }
}
exports.AlipayTradeCreateResponse = AlipayTradeCreateResponse;
class AlipayTradeQueryResponse extends $tea.Model {
    constructor(map) {
        super(map);
    }
    static names() {
        return {
            code: 'code',
            msg: 'msg',
            subCode: 'subCode',
            subMsg: 'subMsg',
            tradeNo: 'tradeNo',
            outTradeNo: 'outTradeNo',
            buyerLogonId: 'buyerLogonId',
            tradeStatus: 'tradeStatus',
            totalAmount: 'totalAmount',
            transCurrency: 'transCurrency',
            settleCurrency: 'settleCurrency',
            settleAmount: 'settleAmount',
            payCurrency: 'payCurrency',
            payAmount: 'payAmount',
            settleTransRate: 'settleTransRate',
            transPayRate: 'transPayRate',
            buyerPayAmount: 'buyerPayAmount',
            pointAmount: 'pointAmount',
            invoiceAmount: 'invoiceAmount',
            sendPayDate: 'sendPayDate',
            receiptAmount: 'receiptAmount',
            storeId: 'storeId',
            terminalId: 'terminalId',
            fundBillList: 'fundBillList',
            storeName: 'storeName',
            buyerUserId: 'buyerUserId',
            chargeAmount: 'chargeAmount',
            chargeFlags: 'chargeFlags',
            settlementId: 'settlementId',
            tradeSettleInfo: 'tradeSettleInfo',
            authTradePayMode: 'authTradePayMode',
            buyerUserType: 'buyerUserType',
            mdiscountAmount: 'mdiscountAmount',
            discountAmount: 'discountAmount',
            buyerUserName: 'buyerUserName',
            subject: 'subject',
            body: 'body',
            alipaySubMerchantId: 'alipaySubMerchantId',
            extInfos: 'extInfos',
        };
    }
    static types() {
        return {
            code: 'string',
            msg: 'string',
            subCode: 'string',
            subMsg: 'string',
            tradeNo: 'string',
            outTradeNo: 'string',
            buyerLogonId: 'string',
            tradeStatus: 'string',
            totalAmount: 'string',
            transCurrency: 'string',
            settleCurrency: 'string',
            settleAmount: 'string',
            payCurrency: 'string',
            payAmount: 'string',
            settleTransRate: 'string',
            transPayRate: 'string',
            buyerPayAmount: 'string',
            pointAmount: 'string',
            invoiceAmount: 'string',
            sendPayDate: 'string',
            receiptAmount: 'string',
            storeId: 'string',
            terminalId: 'string',
            fundBillList: { 'type': 'array', 'itemType': TradeFundBill },
            storeName: 'string',
            buyerUserId: 'string',
            chargeAmount: 'string',
            chargeFlags: 'string',
            settlementId: 'string',
            tradeSettleInfo: { 'type': 'array', 'itemType': TradeSettleInfo },
            authTradePayMode: 'string',
            buyerUserType: 'string',
            mdiscountAmount: 'string',
            discountAmount: 'string',
            buyerUserName: 'string',
            subject: 'string',
            body: 'string',
            alipaySubMerchantId: 'string',
            extInfos: 'string',
        };
    }
}
exports.AlipayTradeQueryResponse = AlipayTradeQueryResponse;
class AlipayTradeRefundResponse extends $tea.Model {
    constructor(map) {
        super(map);
    }
    static names() {
        return {
            code: 'code',
            msg: 'msg',
            subCode: 'subCode',
            subMsg: 'subMsg',
            tradeNo: 'tradeNo',
            outTradeNo: 'outTradeNo',
            buyerLogonId: 'buyerLogonId',
            fundChange: 'fundChange',
            refundFee: 'refundFee',
            refundCurrency: 'refundCurrency',
            gmtRefundPay: 'gmtRefundPay',
            refundDetailItemList: 'refundDetailItemList',
            storeName: 'storeName',
            buyerUserId: 'buyerUserId',
            refundPresetPaytoolList: 'refundPresetPaytoolList',
            refundSettlementId: 'refundSettlementId',
            presentRefundBuyerAmount: 'presentRefundBuyerAmount',
            presentRefundDiscountAmount: 'presentRefundDiscountAmount',
            presentRefundMdiscountAmount: 'presentRefundMdiscountAmount',
        };
    }
    static types() {
        return {
            code: 'string',
            msg: 'string',
            subCode: 'string',
            subMsg: 'string',
            tradeNo: 'string',
            outTradeNo: 'string',
            buyerLogonId: 'string',
            fundChange: 'string',
            refundFee: 'string',
            refundCurrency: 'string',
            gmtRefundPay: 'string',
            refundDetailItemList: { 'type': 'array', 'itemType': TradeFundBill },
            storeName: 'string',
            buyerUserId: 'string',
            refundPresetPaytoolList: { 'type': 'array', 'itemType': PresetPayToolInfo },
            refundSettlementId: 'string',
            presentRefundBuyerAmount: 'string',
            presentRefundDiscountAmount: 'string',
            presentRefundMdiscountAmount: 'string',
        };
    }
}
exports.AlipayTradeRefundResponse = AlipayTradeRefundResponse;
class AlipayTradeCloseResponse extends $tea.Model {
    constructor(map) {
        super(map);
    }
    static names() {
        return {
            code: 'code',
            msg: 'msg',
            subCode: 'subCode',
            subMsg: 'subMsg',
            tradeNo: 'tradeNo',
            outTradeNo: 'outTradeNo',
        };
    }
    static types() {
        return {
            code: 'string',
            msg: 'string',
            subCode: 'string',
            subMsg: 'string',
            tradeNo: 'string',
            outTradeNo: 'string',
        };
    }
}
exports.AlipayTradeCloseResponse = AlipayTradeCloseResponse;
class AlipayTradeCancelResponse extends $tea.Model {
    constructor(map) {
        super(map);
    }
    static names() {
        return {
            code: 'code',
            msg: 'msg',
            subCode: 'subCode',
            subMsg: 'subMsg',
            tradeNo: 'tradeNo',
            outTradeNo: 'outTradeNo',
            retryFlag: 'retryFlag',
            action: 'action',
            gmtRefundPay: 'gmtRefundPay',
            refundSettlementId: 'refundSettlementId',
        };
    }
    static types() {
        return {
            code: 'string',
            msg: 'string',
            subCode: 'string',
            subMsg: 'string',
            tradeNo: 'string',
            outTradeNo: 'string',
            retryFlag: 'string',
            action: 'string',
            gmtRefundPay: 'string',
            refundSettlementId: 'string',
        };
    }
}
exports.AlipayTradeCancelResponse = AlipayTradeCancelResponse;
class Client {
    constructor(_kernel) {
        this._kernel = _kernel;
    }
    async create(subject, outTradeNo, totalAmount, buyerId) {
        let params = {
            subject: subject,
            out_trade_no: outTradeNo,
            total_amount: totalAmount,
            buyer_id: buyerId,
        };
        return $tea.cast(await this._kernel.invoke("alipay.trade.create", params), new AlipayTradeCreateResponse({}));
    }
    async query(tradeNo) {
        let params = {
            trade_no: tradeNo,
        };
        return $tea.cast(await this._kernel.invoke("alipay.trade.query", params), new AlipayTradeQueryResponse({}));
    }
    async refund(outTradeNo, refundAmount) {
        let params = {
            out_trade_no: outTradeNo,
            refund_amount: refundAmount,
        };
        return $tea.cast(await this._kernel.invoke("alipay.trade.refund", params), new AlipayTradeRefundResponse({}));
    }
    async close(outTradeNo) {
        let params = {
            out_trade_no: outTradeNo,
        };
        return $tea.cast(await this._kernel.invoke("alipay.trade.close", params), new AlipayTradeCloseResponse({}));
    }
    async cancel(outTradeNo) {
        let params = {
            out_trade_no: outTradeNo,
        };
        return $tea.cast(await this._kernel.invoke("alipay.trade.cancel", params), new AlipayTradeCancelResponse({}));
    }
}
exports.default = Client;
//# sourceMappingURL=client.js.map