import CloudKernel from 'mpserverless-sdk-core';
import * as $tea from '@alicloud/tea-typescript';
export declare class TradeFundBill extends $tea.Model {
    fundChannel: string;
    bankCode: string;
    amount: string;
    realAmount: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class VoucherDetail extends $tea.Model {
    id: string;
    name: string;
    type: string;
    amount: string;
    merchantContribute: string;
    otherContribute: string;
    memo: string;
    templateId: string;
    purchaseBuyerContribute: string;
    purchaseMerchantContribute: string;
    purchaseAntContribute: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class AlipayTradePayResponse extends $tea.Model {
    code: string;
    msg: string;
    subCode: string;
    subMsg: string;
    tradeNo: string;
    outTradeNo: string;
    buyerLogonId: string;
    settleAmount: string;
    payCurrency: string;
    payAmount: string;
    settleTransRate: string;
    transPayRate: string;
    totalAmount: string;
    transCurrency: string;
    settleCurrency: string;
    receiptAmount: string;
    buyerPayAmount: string;
    pointAmount: string;
    invoiceAmount: string;
    gmtPayment: string;
    fundBillList: TradeFundBill[];
    cardBalance: string;
    storeName: string;
    buyerUserId: string;
    discountGoodsDetail: string;
    voucherDetailList: VoucherDetail[];
    advanceAmount: string;
    authTradePayMode: string;
    chargeAmount: string;
    chargeFlags: string;
    settlementId: string;
    businessParams: string;
    buyerUserType: string;
    mdiscountAmount: string;
    discountAmount: string;
    buyerUserName: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export default class Client {
    _kernel: CloudKernel;
    constructor(_kernel: CloudKernel);
    pay(subject: string, outTradeNo: string, totalAmount: string, authCode: string): Promise<AlipayTradePayResponse>;
}
