"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const $tea = __importStar(require("@alicloud/tea-typescript"));
class TradeFundBill extends $tea.Model {
    constructor(map) {
        super(map);
    }
    static names() {
        return {
            fundChannel: 'fundChannel',
            bankCode: 'bankCode',
            amount: 'amount',
            realAmount: 'realAmount',
        };
    }
    static types() {
        return {
            fundChannel: 'string',
            bankCode: 'string',
            amount: 'string',
            realAmount: 'string',
        };
    }
}
exports.TradeFundBill = TradeFundBill;
class VoucherDetail extends $tea.Model {
    constructor(map) {
        super(map);
    }
    static names() {
        return {
            id: 'id',
            name: 'name',
            type: 'type',
            amount: 'amount',
            merchantContribute: 'merchantContribute',
            otherContribute: 'otherContribute',
            memo: 'memo',
            templateId: 'templateId',
            purchaseBuyerContribute: 'purchaseBuyerContribute',
            purchaseMerchantContribute: 'purchaseMerchantContribute',
            purchaseAntContribute: 'purchaseAntContribute',
        };
    }
    static types() {
        return {
            id: 'string',
            name: 'string',
            type: 'string',
            amount: 'string',
            merchantContribute: 'string',
            otherContribute: 'string',
            memo: 'string',
            templateId: 'string',
            purchaseBuyerContribute: 'string',
            purchaseMerchantContribute: 'string',
            purchaseAntContribute: 'string',
        };
    }
}
exports.VoucherDetail = VoucherDetail;
class AlipayTradePayResponse extends $tea.Model {
    constructor(map) {
        super(map);
    }
    static names() {
        return {
            code: 'code',
            msg: 'msg',
            subCode: 'subCode',
            subMsg: 'subMsg',
            tradeNo: 'tradeNo',
            outTradeNo: 'outTradeNo',
            buyerLogonId: 'buyerLogonId',
            settleAmount: 'settleAmount',
            payCurrency: 'payCurrency',
            payAmount: 'payAmount',
            settleTransRate: 'settleTransRate',
            transPayRate: 'transPayRate',
            totalAmount: 'totalAmount',
            transCurrency: 'transCurrency',
            settleCurrency: 'settleCurrency',
            receiptAmount: 'receiptAmount',
            buyerPayAmount: 'buyerPayAmount',
            pointAmount: 'pointAmount',
            invoiceAmount: 'invoiceAmount',
            gmtPayment: 'gmtPayment',
            fundBillList: 'fundBillList',
            cardBalance: 'cardBalance',
            storeName: 'storeName',
            buyerUserId: 'buyerUserId',
            discountGoodsDetail: 'discountGoodsDetail',
            voucherDetailList: 'voucherDetailList',
            advanceAmount: 'advanceAmount',
            authTradePayMode: 'authTradePayMode',
            chargeAmount: 'chargeAmount',
            chargeFlags: 'chargeFlags',
            settlementId: 'settlementId',
            businessParams: 'businessParams',
            buyerUserType: 'buyerUserType',
            mdiscountAmount: 'mdiscountAmount',
            discountAmount: 'discountAmount',
            buyerUserName: 'buyerUserName',
        };
    }
    static types() {
        return {
            code: 'string',
            msg: 'string',
            subCode: 'string',
            subMsg: 'string',
            tradeNo: 'string',
            outTradeNo: 'string',
            buyerLogonId: 'string',
            settleAmount: 'string',
            payCurrency: 'string',
            payAmount: 'string',
            settleTransRate: 'string',
            transPayRate: 'string',
            totalAmount: 'string',
            transCurrency: 'string',
            settleCurrency: 'string',
            receiptAmount: 'string',
            buyerPayAmount: 'string',
            pointAmount: 'string',
            invoiceAmount: 'string',
            gmtPayment: 'string',
            fundBillList: { 'type': 'array', 'itemType': TradeFundBill },
            cardBalance: 'string',
            storeName: 'string',
            buyerUserId: 'string',
            discountGoodsDetail: 'string',
            voucherDetailList: { 'type': 'array', 'itemType': VoucherDetail },
            advanceAmount: 'string',
            authTradePayMode: 'string',
            chargeAmount: 'string',
            chargeFlags: 'string',
            settlementId: 'string',
            businessParams: 'string',
            buyerUserType: 'string',
            mdiscountAmount: 'string',
            discountAmount: 'string',
            buyerUserName: 'string',
        };
    }
}
exports.AlipayTradePayResponse = AlipayTradePayResponse;
class Client {
    constructor(_kernel) {
        this._kernel = _kernel;
    }
    async pay(subject, outTradeNo, totalAmount, authCode) {
        let params = {
            subject: subject,
            out_trade_no: outTradeNo,
            total_amount: totalAmount,
            auth_code: authCode,
            scene: "bar_code",
        };
        return $tea.cast(await this._kernel.invoke("alipay.trade.pay", params), new AlipayTradePayResponse({}));
    }
}
exports.default = Client;
//# sourceMappingURL=client.js.map