"use strict";
/**
 * check if value is an object
 * @example
 * isObject({}); // => true
 * isObject([1, 2, 3]); // => true
 * isObject(Function); // => true
 * isObject(null); // => false
 * @param {*} value
 * @returns {boolean}
 */
Object.defineProperty(exports, "__esModule", { value: true });
function isObject(value) {
    const type = typeof value;
    return (value !== null && type === 'object') || type === 'function';
}
exports.default = isObject;
//# sourceMappingURL=is-object.js.map