import isString from './is-string';
import isObject from './is-object';
import isNumber from './is-number';

/**
 * set object value by path
 * @example
 * set({ a: 1, b: { c: 2 }}, 'b.c', 3);
 * @param {object} obj
 * @param {string | array} path
 * @param {any} value
 * @returns
 */
export default function set(obj: any, path: string | [string], value: any) {
  let _obj = obj;
  const keyArr = isString(path) ? (<string> path).split('.') : path;

  (<[string]>keyArr).forEach((key, idx) => {
    if (idx < (keyArr.length - 1)) {
      if (!isObject(_obj[key])) {
        _obj[key] = isNumber(keyArr[idx + 1]) ? [] : {};
      }
      _obj = _obj[key];
    } else {
      _obj[key] = value;
    }
  });

  return obj;
}
